Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package doc
  Definition Classes
    nsc
-  package model
  Definition Classes
    doc
-  package diagram
  Definition Classes
    model
- ClassNode
- ContentDiagram
- ContentDiagramDepth
- DepthInfo
- Diagram
- DiagramDirectiveParser
- DiagramFactory
- ImplicitNode
- InheritanceDiagram
- Node
- NormalNode
- ObjectNode
- OtherNode
- OutsideNode
- ThisNode
- TraitNode
- TypeNode

t

scala.tools.nsc.doc.model.diagram

# DiagramDirectiveParser 

###

#### trait DiagramDirectiveParser extends AnyRef

This trait takes care of parsing @{inheritance, content}Diagram annotations

Self Type
  ModelFactory with DiagramFactory with CommentFactory with TreeFactory
Source
  DiagramDirectiveParser.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
DiagramFactory
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. DiagramDirectiveParser
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  case class AnnotationDiagramFilter (hideDiagram: Boolean, hideIncomingImplicits: Boolean, hideOutgoingImplicits: Boolean, hideSuperclasses: Boolean, hideSubclasses: Boolean, hideInheritedNodes: Boolean, hideNodesFilter: List[Pattern], hideEdgesFilter: List[(Pattern, Pattern)]) extends (DiagramDirectiveParser.this)#DiagramFilter with Product with Serializable

   The AnnotationDiagramFilter trait directs the diagram engine according to an annotation TODO: Should document the annotation, for now see parseDiagramAnnotation in ModelFactory.scala

2.  trait DiagramFilter extends AnyRef

   The DiagramFilter trait directs the diagram engine about the way the diagram should be displayed

   The DiagramFilter trait directs the diagram engine about the way the diagram should be displayed

   Vlad: There's an explanation I owe to people using diagrams and not finding a way to hide a specific class from all diagrams at once. So why did I choose to allow you to only control the diagrams at class level? So, the reason is you would break the separate scaladoc compilation: If you have an "@diagram hideMyClass" annotation in class A and you run scaladoc on it along with its subclass B A will not appear in B's diagram. But if you scaladoc only on B, A's comment will not be parsed and the instructions to hide class A from all diagrams will not be available. Thus I prefer to force you to control the diagrams of each class locally. The problem does not appear with scalac, as scalac stores all its necessary information (like scala signatures) serialized in the .class file. But we couldn't store doc comments in the class file, could we? (Turns out we could, but that's another story)

   Any flaming for this decision should go to scala-internals@googlegroups.com

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from DiagramDirectiveParser to any2stringadd[DiagramDirectiveParser] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (DiagramDirectiveParser, B)
   Implicit
     This member is added by an implicit conversion from DiagramDirectiveParser to ArrowAssoc[DiagramDirectiveParser] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
8.  def ensuring(cond: (DiagramDirectiveParser) ⇒ Boolean, msg: ⇒ Any): DiagramDirectiveParser
   Implicit
     This member is added by an implicit conversion from DiagramDirectiveParser to Ensuring[DiagramDirectiveParser] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
9.  def ensuring(cond: (DiagramDirectiveParser) ⇒ Boolean): DiagramDirectiveParser
   Implicit
     This member is added by an implicit conversion from DiagramDirectiveParser to Ensuring[DiagramDirectiveParser] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: Boolean, msg: ⇒ Any): DiagramDirectiveParser
    Implicit
      This member is added by an implicit conversion from DiagramDirectiveParser to Ensuring[DiagramDirectiveParser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean): DiagramDirectiveParser
    Implicit
      This member is added by an implicit conversion from DiagramDirectiveParser to Ensuring[DiagramDirectiveParser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
13.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
14.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
15.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from DiagramDirectiveParser to StringFormat[DiagramDirectiveParser] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
16.  final def getClass(): java.lang.Class[_]
    Definition Classes
      AnyRef → Any
17.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
18.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
19.  def makeContentDiagramFilter(template: (DiagramDirectiveParser.this)#DocTemplateImpl): (DiagramDirectiveParser.this)#DiagramFilter

    Main entry point into this trait: generate the filter for content diagrams

20.  def makeInheritanceDiagramFilter(template: (DiagramDirectiveParser.this)#DocTemplateImpl): (DiagramDirectiveParser.this)#DiagramFilter

    Main entry point into this trait: generate the filter for inheritance diagrams

21.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
22.  final def notify(): Unit
    Definition Classes
      AnyRef
23.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
24.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
25.  val tFilter: Long
    Attributes
      protected
26.  val tModel: Long
    Attributes
      protected
27.  def toString(): String
    Definition Classes
      AnyRef → Any
28.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
29.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
30.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
31.  def →[B](y: B): (DiagramDirectiveParser, B)
    Implicit
      This member is added by an implicit conversion from DiagramDirectiveParser to ArrowAssoc[DiagramDirectiveParser] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc
32.  object FullDiagram extends (DiagramDirectiveParser.this)#DiagramFilter with Product with Serializable

    Show the entire diagram, no filtering

33.  object NoDiagramAtAll extends (DiagramDirectiveParser.this)#DiagramFilter with Product with Serializable

    Hide the diagram completely, no need for special filtering

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from DiagramDirectiveParser to any2stringadd[DiagramDirectiveParser]

### Inherited by implicit conversion StringFormat from DiagramDirectiveParser to StringFormat[DiagramDirectiveParser]

### Inherited by implicit conversion Ensuring from DiagramDirectiveParser to Ensuring[DiagramDirectiveParser]

### Inherited by implicit conversion ArrowAssoc from DiagramDirectiveParser to ArrowAssoc[DiagramDirectiveParser]

### Ungrouped